#  Copyright (C) 2011 by Carnegie Mellon University.
#  
#  @OPENSOURCE_HEADER_START@
#  Use of the Network Situational Awareness Portal and related source
#  code is subject to the terms of the following licenses:
#  
#  GNU Public License (GPL) Rights pursuant to Version 2, June 1991
#  Government Purpose License Rights (GPLR) pursuant to DFARS 252.225-7013
#  
#  NO wARRANTY
#  
#  ANY INFORMATION, MATERIALS, SERVICES, INTELLECTUAL PROPERTY OR OTHER 
#  PROPERTY OR RIGHTS GRANTED OR PROVIDED BY CARNEGIE MELLON UNIVERSITY 
#  PURSUANT TO THIS LICENSE (HEREINAFTER THE "DELIVERABLES") ARE ON AN 
#  "AS-IS" BASIS. CARNEGIE MELLON UNIVERSITY MAKES NO wARRANTIES OF ANY 
#  KIND, EITHER EXPRESS OR IMPLIED AS TO ANY MATTER INCLUDING, BUT NOT 
#  LIMITED TO, wARRANTY OF FITNESS FOR A PARTICULAR PURPOSE, 
#  MERCHANTABILITY, INFORMATIONAL CONTENT, NONINFRINGEMENT, OR ERROR-FREE 
#  OPERATION. CARNEGIE MELLON UNIVERSITY SHALL NOT BE LIABLE FOR INDIRECT, 
#  SPECIAL OR CONSEQUENTIAL DAMAGES, SUCH AS LOSS OF PROFITS OR INABILITY 
#  TO USE SAID INTELLECTUAL PROPERTY, UNDER THIS LICENSE, REGARDLESS OF 
#  wHETHER SUCH PARTY wAS AWARE OF THE POSSIBILITY OF SUCH DAMAGES. 
#  LICENSEE AGREES THAT IT wILL NOT MAKE ANY wARRANTY ON BEHALF OF 
#  CARNEGIE MELLON UNIVERSITY, EXPRESS OR IMPLIED, TO ANY PERSON 
#  CONCERNING THE APPLICATION OF OR THE RESULTS TO BE OBTAINED wITH THE 
#  DELIVERABLES UNDER THIS LICENSE.
#  
#  Licensee hereby agrees to defend, indemnify, and hold harmless Carnegie 
#  Mellon University, its trustees, officers, employees, and agents from 
#  all claims or demands made against them (and any related losses, 
#  expenses, or attorney's fees) arising out of, or relating to Licensee's 
#  and/or its sub licensees' negligent use or willful misuse of or 
#  negligent conduct or willful misconduct regarding the Software, 
#  facilities, or other rights or assistance granted by Carnegie Mellon 
#  University under this License, including, but not limited to, any 
#  claims of product liability, personal injury, death, damage to 
#  property, or violation of any laws or regulations.
#  
#  Carnegie Mellon University Software Engineering Institute authored 
#  documents are sponsored by the U.S. Department of Defense under 
#  Contract FA8721-05-C-0003. Carnegie Mellon University retains 
#  copyrights in all material produced under this contract. The U.S. 
#  Government retains a non-exclusive, royalty-free license to publish or 
#  reproduce these documents, or allow others to do so, for U.S. 
#  Government purposes only pursuant to the copyright license under the 
#  contract clause at 252.227.7013.
#  @OPENSOURCE_HEADER_END@
from __future__ import division
"""
Old way of doing font sizing in the text module. Deprecated, and will
disappear soon.
"""
import math
import copy

import markers
import lines
import miscutils


#font_sizes = {
#    # Note: The first element of this list should always be (0, ...)
#    'normal' : ((0, 6), (400, 8), (800, 10),),
#    'large' : ((0, 8), (400, 12), (800, 15),),
#    'x-large' : ((0, 10), (400, 10), (800, 12),),
#}


# This is the point size for a normal font at 800 pixels wide/high
font_base_size = 10
font_size_modifiers = (('x-small'  ,  .50), # 6  px
                       ('small'    ,  .75), # 9  px
                       ('normal'   , 1.00), # 12 px, e.g.
                       ('large'    , 1.75), # 15 px
                       ('x-large'  , 2.25), # 18 px
                       ('xx-large' , 3.00), # 21 px
                       ('xxx-large', 4.00)) # 24 px
window_size_modifiers = ((0, 0),
                         ( 400,  .75),
                         ( 800, 1.00),
                         (1000, 1.25),
                         (1200, 1.50),
                         (1400, 1.75))

font_sizes = dict((label, tuple((w_sz, font_base_size * w_sf * f_sf)
                                for w_sz, w_sf in window_size_modifiers))
     for label, f_sf in font_size_modifiers)


def get_point_size(font_size, canvas_width, canvas_height):
    """Map a given font size to a point size, given the width of the
    whole canvas."""
    sizes = font_sizes[font_size]
    # Use point size corresponding to largest scale width (width
    # or height, as appropriate)
    pointsize = None
    # we should never get negative scale widths, and probably
    # should never get scale widths == 0, but just in case....
    if canvas_width <= 0:
        pointsize = sizes[0][1]
    else:
        for idx, (w, sz) in enumerate(sizes):
            if canvas_width < w:
                return sizes[idx-1][1]
    # canvas_width is >= the largest width
    return sizes[-1][1]
